require 'wpf'

# Create window
my_window = Window.new
my_window.width = 700
my_window.height = 580
my_window.title = 'IronRubyWesabeMoney by Scott Hanselman and unnamed and uncredited intern. Who you ask? Exactly. Previously known as SuperKarateMonkeyDeathCar in IronRuby.'


my_wrap1 = WrapPanel.new
my_wrap1.margin = Thickness.new 10 
my_wrap2 = WrapPanel.new
my_wrap2.margin = Thickness.new 10 

# Create StackPanel to Layout UI elements 
my_stack = StackPanel.new
my_stack.margin = Thickness.new 15 
my_window.content = my_stack
my_stack.children.add my_wrap1
my_stack.children.add my_wrap2

label_user = Label.new
label_user.content = "Username:"
label_user.font_size = 24
label_user.width = 200
my_wrap1.children.add label_user

text_user = TextBox.new
text_user.text = ""
text_user.font_size = 24
text_user.width = 300
my_wrap1.children.add text_user

label_password = Label.new
label_password.content = "Password:"
label_password.font_size = 24
label_password.width = 200
my_wrap2.children.add label_password

text_password = PasswordBox.new
text_password.password = ""
text_password.font_size = 24
text_password.width = 300
my_wrap2.children.add text_password


# Create Button and use a Ruby block to handle the Button Click event
my_button = Button.new
my_button.content = 'Get Accounts'
my_button.font_size = 24
my_button.bitmap_effect = DropShadowBitmapEffect.new
my_stack.children.add my_button

accounts_listbox = ListBox.new
accounts_listbox.font_size = 24
my_stack.children.add accounts_listbox

my_button.click do |sender, args|

   a = Wesabe.getAccounts(text_user.text,text_password.password)
   #in the future this will happen automatically...
   # Length is converted to a Ruby FixNum, and to_s makes it a string, while
   #  to_clr_string makes it a System::String
   #MessageBox.Show(a.Items.Length.to_s.to_clr_string)
   
   #an Array of Accounts
   myAccounts = a.Items
   #in the future we'll be able to index into CLR arrays...
   #oneAccount = myAccounts[0]
   i = 0
   #We can't use this because i is a FixNum, and "for" is syntactic sugar
   # on top of "each". In this build, each isn't implemented, so we'll cheat
   # and use while.
   # System.MissingMethodException: undefined local variable or method `each' for 5:Fixnum
   #for i in a.Items.Length
   accounts_listbox.items.clear
   while (i < a.Items.Length)
      oneAccount = myAccounts.GetValue(i) #GetValue is on System.Array
      #I originally was using a System.Single, but IronRuby wasn't digging it
      # so I went to a System.Double, and the ToString worked.
      #MessageBox.Show(oneAccount.currentBalance.to_s.to_clr_string)
      i+=1 #needed for the while
      
      # Create new label
      my_message = Label.new
      my_message.font_size = 36
      #currentBalance.to_string("C") didn't work, so overloads might not be ready yet, so I'm cheating with the $
      #my_message.content = oneAccount.name + oneAccount.currentBalance.to_string("C").to_clr_string
      
      #my_message.content = oneAccount.name + "$" + oneAccount.currentBalance.to_s.to_clr_string
      
      #There's a name conflict when trying to use the StringBuilder:
      # System.MemberAccessException: uninitialized constant ScriptModule::Text
      #s = System::Text::StringBuilder.new
      #s.Append(oneAccount.name)
      #s.Append("$")
      #s.Append(oneAccount.currentBalance.to_s.to_clr_string)
      #my_message.content = s.to_string

      my_message.content = oneAccount.DisplayString
      
      #Ruby string concatenation works fine...
      #my_message.content = "scott" + " hanselman"

      # Add label into stack panel of controls
      accounts_listbox.items.add(my_message)
   end
   
   
end


# Run application
my_app = Application.new
my_app.run my_window
